package com.example.museum2;

import android.content.Intent;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.ActionBarDrawerToggle;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.core.view.GravityCompat;
import androidx.drawerlayout.widget.DrawerLayout;

import com.google.android.material.navigation.NavigationView;

public class Main_page extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {

    DrawerLayout drawerLayout;
    NavigationView navigationView;
    Toolbar toolbar;
    RelativeLayout museum_clickable,caffee_clickable,souvenir_clickable,payment_clickable;

    String UsernameHolder;
    TextView Username;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_page);

        drawerLayout = findViewById(R.id.drawer_layout);
        navigationView = findViewById(R.id.nav_view);
        toolbar = findViewById(R.id.toolbar);
        museum_clickable = findViewById(R.id.museum_clickable);
        caffee_clickable = findViewById(R.id.caffe_clickable);
        souvenir_clickable = findViewById(R.id.souvenir_shop_clickable);
        payment_clickable = findViewById(R.id.payment_clickable);

        Intent intent = getIntent();
        Username = (TextView)findViewById(R.id.test);

        // Receiving User Email Send By MainActivity.
        Bundle bundle = intent.getExtras();

        UsernameHolder = bundle.getString("username");

        // Setting up received email to TextView.
        Username.setText("Hi, " + UsernameHolder);


        setSupportActionBar(toolbar);
       /* getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);*/
        getSupportActionBar().setDisplayShowTitleEnabled(false);

        navigationView.bringToFront();
        ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(this,drawerLayout,toolbar,R.string.navigation_drawer_open,R.string.navigation_drawer_close);
        drawerLayout.addDrawerListener(toggle);
        toggle.syncState();

        navigationView.setNavigationItemSelectedListener(this);
        navigationView.setCheckedItem(R.id.nav_home);

        //museum click
        museum_clickable.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                Intent intent = new Intent(Main_page.this, Museums.class);
                startActivity(intent);
            }
        });


        souvenir_clickable.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                Intent intent = new Intent(Main_page.this, Souvenir.class);
                startActivity(intent);
            }
        });

        caffee_clickable.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                Intent intent = new Intent(Main_page.this, Caffee.class);
                startActivity(intent);
            }
        });

        payment_clickable.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                Intent intent = new Intent(Main_page.this, Pay.class);
                startActivity(intent);
            }
        });

    }

    @Override
    public void onBackPressed() {

        if(drawerLayout.isDrawerOpen(GravityCompat.START)){
            drawerLayout.closeDrawer(GravityCompat.START);
        }
        else{
            super.onBackPressed();
        }

    }

    @Override
    public boolean onNavigationItemSelected(@NonNull MenuItem menuItem) {

        switch (menuItem.getItemId()){

            case R.id.nav_home:
                break;
            case R.id.nav_museums:
                Intent intent = new Intent(Main_page.this,Museums.class);
                startActivity(intent);
                break;
            case R.id.nav_coffee:
                Intent intent2 = new Intent(Main_page.this,Caffee.class);
                startActivity(intent2);
                break;
            case R.id.nav_souvenir_shop:
                Intent intent3 = new Intent(Main_page.this,Souvenir.class);
                startActivity(intent3);
                break;
            case R.id.nav_payment:
                Intent intent4 = new Intent(Main_page.this,Pay.class);
                startActivity(intent4);
                break;
            case R.id.nav_share:
                Toast.makeText(this,"Share",Toast.LENGTH_SHORT).show();
                break;
            case R.id.nav_logout:
                Intent intent5 = new Intent(Main_page.this,MainActivity.class);
                startActivity(intent5);
                break;
        }


        drawerLayout.closeDrawer(GravityCompat.START);
        return true;
    }

    @Override
    public void onPointerCaptureChanged(boolean hasCapture) {

    }
}

